<template>
  <header class="desktop-header d-none d-lg-flex align-items-center mt-1 mb-1">
    <div class="container">
      <div class="row align-items-center">
        <div class="col-lg-9 px-0">
          <form @submit.prevent="search()">
            <input
              type="search"
              class="form-control"
              placeholder="Buscar productos o categorías"
              v-model="query"
              @focus="showRecentSearch = true"
            />

            <div
              class="recent-search bg-white py-4 px-3 shadow-card animate__animated animate__fadeInDown animate__faster"
              v-if="showRecentSearch && getRecentSearches.length"
            >
              <div class="d-flex justify-content-between align-items-center">
                <span class="title text-uppercase">Búsquedas recientes</span>
                <b-button
                  variant="default"
                  size="sm"
                  class="small text-muted"
                  @click="editing = !editing"
                >
                  Editar
                </b-button>
              </div>

              <section>
                <SearchBadge
                  :text="item"
                  :show-remove="editing"
                  class="mt-2 mr-3"
                  v-for="(item, index) in getRecentSearches"
                  :key="index"
                  @redirect="showRecentSearch = false"
                />
              </section>
            </div>
          </form>
        </div>

        <div class="col-lg-2">
          <div class="d-flex flex-column text-right">
            <span class="font-weight-bold">Bienvenid@</span>
            <!-- <a
              href=""
              class="small"
              @click.prevent="$bvModal.show('modal-auth')"
            >
              Iniciar sesión
              <i class="fas fa-chevron-right" aria-hidden="true"></i>
            </a> -->
          </div>
        </div>

        <div class="col-lg-1 h-100 d-flex align-items-center">
          <ShoppingCartCount
            class="border-0 mt-2 mr-3"
            @click="$router.push({ name: 'carrito' })"
          />
        </div>
      </div>
    </div>

    <div class="overlay animate__animated animate__fadeIn" v-if="showRecentSearch" @click="showRecentSearch = false"></div>
  </header>
</template>

<script>
import searchMixin from "@/mixins/search.js";

import {
  getRecentSearches,
  addRecentSearches,
} from "@/services/recent-searches.js";

import ShoppingCartCount from "../ShoppingCartCount.vue";

export default {
  mixins: [searchMixin],
  data() {
    return {
      showRecentSearch: false,
    };
  },
  mounted() {
    if (process.client) this.initRecentSearches();
  },
  components: {
    ShoppingCartCount,
  },
  methods: {
    search() {
      addRecentSearches(this.query);

      this.$router.push({ name: "buscar-productos", query: { q: this.query } });

      this.showRecentSearch = false
      this.$bvModal.hide("modal-mobile-search");

      this.initRecentSearches();
    },
    hideSubNav() {
      setTimeout(() => {
        this.showRecentSearch = false;
      }, 200);
    },
  },
};
</script>

<style lang="scss" scoped>
.desktop-header {
  height: 60px;

  .form-control {
    max-width: 90%;
  }

  .recent-search {
    width: 90%;

    position: absolute;
    left: 0;
    top: 100%;
    z-index: 30;

    .title {
      font-size: 0.95em;
      text-transform: uppercase;
    }
  }

  .overlay {
    background-color: rgba(white, .2);

    position: fixed;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    z-index: 20;
  }
}
</style>
